"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.configureWithClientMainQuery = void 0;

var _reactRedux = require("react-redux");

var _lifecycle = _interopRequireDefault(require("recompose/lifecycle"));

var _compose = _interopRequireDefault(require("recompose/compose"));

/* eslint-disable import/no-extraneous-dependencies */
// flow-disable-next-line
var configuredFetchPageThunk;

var configureWithClientMainQuery = function configureWithClientMainQuery(fetchPageThunk) {
  configuredFetchPageThunk = fetchPageThunk;
};

exports.configureWithClientMainQuery = configureWithClientMainQuery;
var lifecycle = {
  componentDidMount: function componentDidMount() {
    if (!this.props.isFirstRender) {
      if (!configuredFetchPageThunk) {
        throw Error('You must configure a fetchPageThunk with configureWithClientMainQuery');
      }

      var _this$props = this.props,
          dispatch = _this$props.dispatch,
          route = _this$props.route;

      if (route.mainQuery) {
        var urlParams = this.props.match.params;
        var _route$mainQuery = route.mainQuery,
            query = _route$mainQuery.query,
            mapUrlParams = _route$mainQuery.mapUrlParams,
            mapResp = _route$mainQuery.mapResp;
        dispatch(configuredFetchPageThunk({
          query: query,
          urlParams: urlParams,
          mapUrlParams: mapUrlParams,
          mapResp: mapResp
        }));
      }
    }
  }
};
var withClientMainQuery = (0, _compose.default)((0, _reactRedux.connect)(function (_ref) {
  var env = _ref.env;
  return {
    isFirstRender: env.isFirstRender
  };
}), (0, _lifecycle.default)(lifecycle));
var _default = withClientMainQuery;
exports.default = _default;